show.c

LISP Interpreter Run

[[[
 Show that a formal system of complexity N
 can't prove that a specific object has
 complexity > N + 735.
 Formal system is a never halting lisp expression
 that displays pairs (lisp object, lower bound
 on its complexity).  E.g., (x(1111)) means
 that x has complexity H(x) greater than or equal to 4.
]]]

[ (<xy) tells if x is less than y ]
& (<xy) /.y0 /.x1 <-x-y

<:          (&(xy)(/(.y)0(/(.x)1(<(-x)(-y)))))

<'(11)'(11)

expression  (<('(11))('(11)))
value       0

<'(11)'(111)

expression  (<('(11))('(111)))
value       1

<'(111)'(11)

expression  (<('(111))('(11)))
value       0


[ Search list p for first s in pair (s,m) with H(s) >= m > n ]
[ (Returns 0/false to indicate not found.) ]
& (Epn) /.p 0 /<n+-+p ++p E-pn

E:          (&(pn)(/(.p)0(/(<n(+(-(+p))))(+(+p))(E(-p)n))))

E'((x(11))(y(111)))'()

expression  (E('((x(11))(y(111))))('()))
value       x

E'((x(11))(y(111)))'(1)

expression  (E('((x(11))(y(111))))('(1)))
value       x

E'((x(11))(y(111)))'(11)

expression  (E('((x(11))(y(111))))('(11)))
value       y

E'((x(11))(y(111)))'(111)

expression  (E('((x(11))(y(111))))('(111)))
value       0

E'((x(11))(y(111)))'(1111)

expression  (E('((x(11))(y(111))))('(1111)))
value       0


++?0'!%  [[Universal binary computer U]]
         [[Put together program for U:]]
^#~'     [[Show crucial prefix so can size it]]
"(       [[begin literally]]

[ (<xy) tells if x is less than y ]
: (<xy) /.y1 /.x1 <-x-y    [[ BAD DEFINITION!!! ALWAYS TRUE ]]

[ Search list p for first s in pair (s,m) with H(s) >= m > n ]
[ (Returns 0/false to indicate not found.) ]
: (Epn) /.p 0 /<n+-+p ++p E-pn

[Main Loop - t is depth limit (time),
             b is bits of FAS read so far (buffer)]
:(Ltb)
 :v ?t'!%b  [Run FAS for time t.]
            [Look for s-exp s that is proved to have complexity H(s)]
 :s E-v^b'{735} [ > 735 + # of bits of FAS read.]
 /s s       [Found it!  Output it and halt.]
            [Contradiction: our value has complexity
             greater than our size!]
            [Our size is 735 bits + the number of bits of
             the FAS that were read at the point that the
             search succeeded (some bits of the FAS may be
             unread).]
 /="!+v  L   t ^b*@()  [Read another bit of FAS.]
 /="?+v  L *1t  b      [Increase depth/time limit.]
 "?     [Surprise, formal system halts, so we do too.]

L()()   [Initially, 0 depth limit and no bits read.]

 )      [[end literally]]

#'
"(      [[begin literally]]

[[This is the FAS]]
,'((xy)(11))  [FAS = {"H((xy)) >= 2"}]

 )      [[end literally]]

expression  (+(+(?0('(!(%)))(^(#(~('(:(<xy)/.y1/.x1<-x-y:(Epn)
            /.p0/<n+-+p++pE-pn:(Ltb):v?t'!%b:sE-v^b'{735}/ss/=
            "!+vLt^b*@()/="?+vL*1tb"?L()()))))(#('(,'((xy)(11)
            ))))))))
show        (:(<xy)/.y1/.x1<-x-y:(Epn)/.p0/<n+-+p++pE-pn:(Ltb)
            :v?t'!%b:sE-v^b'{735}/ss/="!+vLt^b*@()/="?+vL*1tb"
            ?L()())
size        105/735
value       (xy)

End of LISP Run

Elapsed time is 0 seconds.
