lisp.c

LISP Interpreter Run

[[[
 Test basic (finite) set functions.
]]]

[Set membership predicate; is e in set s?]
& (Mes) /.s0 /=e+s1 Me-s

M:          (&(es)(/(.s)0(/(=e(+s))1(Me(-s)))))

Mx'(12345xabcde)

expression  (Mx('(12345xabcde)))
value       1

Mq'(12345xabcde)

expression  (Mq('(12345xabcde)))
value       0

[Eliminate duplicate elements from set s]
& (Ds) /.s() /M+s-s D-s *+sD-s

D:          (&(s)(/(.s)()(/(M(+s)(-s))(D(-s))(*(+s)(D(-s))))))

D'(1234512345abcde)

expression  (D('(1234512345abcde)))
value       (12345abcde)

DD'(1234512345abcde)

expression  (D(D('(1234512345abcde))))
value       (12345abcde)

[Set union]
& (Uxy) /.xy /M+xy U-xy *+xU-xy

U:          (&(xy)(/(.x)y(/(M(+x)y)(U(-x)y)(*(+x)(U(-x)y)))))

U'(12345abcde)'(abcde67890)

expression  (U('(12345abcde))('(abcde67890)))
value       (12345abcde67890)

[Set intersection]
& (Ixy) /.x() /M+xy *+xI-xy I-xy

I:          (&(xy)(/(.x)()(/(M(+x)y)(*(+x)(I(-x)y))(I(-x)y))))

I'(12345abcde)'(abcde67890)

expression  (I('(12345abcde))('(abcde67890)))
value       (abcde)

[Subtract set y from set x]
& (Sxy) /.x() /M+xy S-xy *+xS-xy

S:          (&(xy)(/(.x)()(/(M(+x)y)(S(-x)y)(*(+x)(S(-x)y)))))

S'(12345abcde)'(abcde67890)

expression  (S('(12345abcde))('(abcde67890)))
value       (12345)

[Identity function that displays a set of elements]
& (Os) /.s() *,+sO-s

O:          (&(s)(/(.s)()(*(,(+s))(O(-s)))))

O'(12345abcde)

expression  (O('(12345abcde)))
display     1
display     2
display     3
display     4
display     5
display     a
display     b
display     c
display     d
display     e
value       (12345abcde)

[Combine two bit strings by interleaving them]
& (Cxy) /.xy /.yx *+x*+yC-x-y

C:          (&(xy)(/(.x)y(/(.y)x(*(+x)(*(+y)(C(-x)(-y)))))))

C'(0000000000)'(11111111111111111111)

expression  (C('(0000000000))('(11111111111111111111)))
value       (010101010101010101011111111111)

End of LISP Run

Elapsed time is 0 seconds.
