show.c

LISP Interpreter Run

[[[
 Show that
    H(X set-union Y) <= H(X) + H(Y) + 1799
 and that
    H(X set-intersection Y) <= H(X) + H(Y) + 1799.
 Here X and Y are INFINITE sets.
]]]

[Combine two bit strings by interleaving them]
& (Cxy) /.xy /.yx *+x*+yC-x-y

C:          (&(xy)(/(.x)y(/(.y)x(*(+x)(*(+y)(C(-x)(-y)))))))


& (Dl) /.l"? ('&(xy)x D-l ,+l) [Display list in reverse]

D:          (&(l)(/(.l)?(('(&(xy)x))(D(-l))(,(+l)))))


D-
[[[++]]]?0'!%

^#~'"( [begin literally]

[Package of set functions from sets0.l]
: (Mes) /.s0 /=e+s1 Me-s
: (Ds) /.s() /M+s-s D-s *+sD-s
: (Uxy) /.xy /M+xy U-xy *+xU-xy
: (Ixy) /.x() /M+xy *+xI-xy I-xy
: (Sxy) /.x() /M+xy S-xy *+xS-xy
: (Os) /.s() *,+sO-s
[Main Loop:
 o is set of elements output so far.
 For first set,
 t is depth limit (time), b is bits read so far.
 For second set,
 u is depth limit (time), c is bits read so far.
]
: (Lotbuc)
 : v     ?t'!%b      [Run 1st computation again.]
 : w     ?u'!%c      [Run 2nd computation again.]
 : x     I-v-w       [Form INTERSECTION of sets so far]
 : y     OSxo        [Output all new elements]
 [This is an infinite loop. But to make debugging easier,
  halt if EITHER computation has halted.]
 / /=0.+v1 /=0.+w1 0 "?
 [Bump everything before branching to head of loop]
 L x                 [Value of y is discarded, x is new o]
   /="?+v *1t    t   [Increment time for 1st computation]
   /="!+v ^b*@() b   [Increment tape for 1st computation]
   /="?+w *1u    u   [Increment time for 2nd computation]
   /="!+w ^c*@() c   [Increment tape for 2nd computation]

L()()()()()          [Initially all 5 induction variables
                      are empty.]
)                    [end literally]

C                    [Combine their bits in order needed]
                     [Wrong order if programs use @ or %]
#'"( *,a*,b*,c0 )    [Program to enumerate 1st FINITE set]
#'"( *,b*,c*,d0 )    [Program to enumerate 2nd FINITE set]

expression  (D(-(?0('(!(%)))(^(#(~('(:(Mes)/.s0/=e+s1Me-s:(Ds)
            /.s()/M+s-sD-s*+sD-s:(Uxy)/.xy/M+xyU-xy*+xU-xy:(Ix
            y)/.x()/M+xy*+xI-xyI-xy:(Sxy)/.x()/M+xyS-xy*+xS-xy
            :(Os)/.s()*,+sO-s:(Lotbuc):v?t'!%b:w?u'!%c:xI-v-w:
            yOSxo//=0.+v1/=0.+w10"?Lx/="?+v*1tt/="!+v^b*@()b/=
            "?+w*1uu/="!+w^c*@()cL()()()()()))))(C(#('(*,a*,b*
            ,c0)))(#('(*,b*,c*,d0))))))))
show        (:(Mes)/.s0/=e+s1Me-s:(Ds)/.s()/M+s-sD-s*+sD-s:(Ux
            y)/.xy/M+xyU-xy*+xU-xy:(Ixy)/.x()/M+xy*+xI-xyI-xy:
            (Sxy)/.x()/M+xyS-xy*+xS-xy:(Os)/.s()*,+sO-s:(Lotbu
            c):v?t'!%b:w?u'!%c:xI-v-w:yOSxo//=0.+v1/=0.+w10"?L
            x/="?+v*1tt/="!+v^b*@()b/="?+w*1uu/="!+w^c*@()cL()
            ()()()())
size        257/1799
display     c
display     b
value       ?

End of LISP Run

Elapsed time is 0 seconds.
